<!DOCTYPE html>

<html lang="en">
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width">
	<title>Plait Webview Docs Source: url_routing.js</title>

	<!--[if lt IE 9]>
	<script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
	<![endif]-->
	<link type="text/css" rel="stylesheet" href="styles/sunlight.default.css">

	<link type="text/css" rel="stylesheet" href="styles/site.cosmo.css">

</head>

<body>

<div class="navbar navbar-default navbar-fixed-top navbar-inverse">
<div class="container">
	<div class="navbar-header">
		<a class="navbar-brand" href="index.html">Plait Webview Docs</a>
		<button class="navbar-toggle" type="button" data-toggle="collapse" data-target="#topNavigation">
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
        </button>
	</div>
	<div class="navbar-collapse collapse" id="topNavigation">
		<ul class="nav navbar-nav">
			
			<li class="dropdown">
				<a href="namespaces.list.html" class="dropdown-toggle" data-toggle="dropdown">Namespaces<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="socket.html">socket</a></li>
				</ul>
			</li>
			
			<li class="dropdown">
				<a href="classes.list.html" class="dropdown-toggle" data-toggle="dropdown">Classes<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="Control.html">Control</a></li><li><a href="SessionControl.html">SessionControl</a></li><li><a href="Collection.html">Collection</a></li><li><a href="Overview.html">Overview</a></li><li><a href="Plugins.html">Plugins</a></li><li><a href="Editor.html">Editor</a></li><li><a href="FileMenu.html">FileMenu</a></li><li><a href="Form.html">Form</a></li><li><a href="Routing.html">Routing</a></li>
				</ul>
			</li>
			
			<li class="dropdown">
				<a href="global.html" class="dropdown-toggle" data-toggle="dropdown">Global<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="global.html#routing">routing</a></li><li><a href="global.html#control">control</a></li><li><a href="global.html#showSessions">showSessions</a></li><li><a href="global.html#TabButton">TabButton</a></li><li><a href="global.html#CueButton">CueButton</a></li><li><a href="global.html#CueBar">CueBar</a></li><li><a href="global.html#form">form</a></li><li><a href="global.html#editor">editor</a></li><li><a href="global.html#addGame">addGame</a></li><li><a href="global.html#createGame">createGame</a></li><li><a href="global.html#removeGame">removeGame</a></li><li><a href="global.html#inputPrompt">inputPrompt</a></li><li><a href="global.html#confirmation">confirmation</a></li><li><a href="global.html#identifyBrowser">identifyBrowser</a></li><li><a href="global.html#generateUUID">generateUUID</a></li><li><a href="global.html#namespace">namespace</a></li>
				</ul>
			</li>
			
		</ul>
        
            <div class="col-sm-3 col-md-3">
                <form class="navbar-form" role="search">
                    <div class="input-group">
                        <input type="text" class="form-control" placeholder="Search" name="q" id="search-input">
                        <div class="input-group-btn">
                            <button class="btn btn-default" id="search-submit"><i class="glyphicon glyphicon-search"></i></button>
                        </div>
                    </div>
                </form>
            </div>
        
	</div>

</div>
</div>


<div class="container" id="toc-content">
<div class="row">

	
	<div class="col-md-12">
	
		<div id="main">
			

		<h1 class="page-title">Source: url_routing.js</h1>
    
<section>
    <article>
        <pre
            class="sunlight-highlight-javascript linenums">/**
* @file url_routing
* organise routing based on url
* @copyright Lasse Marburg 2020
* @license GPLv3
*/

/**
* allows to store reactions that are triggered on url changes.
* callbacks are stored sorted using the subaddress they are bound to
*
* uses window popstate event to listen for url changes
*
* holds its own history to allow to go back to previous pages even if only the hash changed
*
* @param {string} base_url - subaddress under which the Routing instance starts
*/
class Routing {
  constructor(base_url) {
    /** local history */
    this.history = []
    
    /** stores all callbacks that where registered under a certain path */
    this.routes = {}
    
    this.base_url = base_url
    console.log("Address routing enabled for " + base_url)
    
    /*
    $(window).on('hashchange', () => {
      console.log("hashchange")
      this.review()
    })
    */
    
    $(window).on('popstate', (e) => {
      console.log("popstate event")
      console.log(e)
      this.review()
    })
  }
  
  /**
  * Store a new callback under a specific path and/or hash or add hashes and link elements to existing callbacks.
  * 
  * you may connect the path and/or hash to a DOM element.  
  * for `&lt;a>` elements href property is added.  
  * for all others a click handler is added to the element.
  *
  * If you provide different callbacks for hash and path, they are called successively if url includes the hash. The hash callback will only be run once the path callback returns. The callback can also return a promise.
  * 
  * Add `symbolic:true` to args if you want to prevent the hash callback from being run after path callback. For example if they do the same thing.
  * See review {@link Routing#review} function for details.
  *
  * @param {Object} args - specify what routing to add
  * @param {string} args.path - subadress that will be routed
  * @param {string} [args.hash] - using hash, callback and link will be bound to hash and path
  * @param {Object} [args.link] - DOM element that will change the url on click
  * @param {boolean} [args.symbolic=undefined] - if set true will prevent triggering content twice if hash is synonym to address
  * @param {boolean} [args.exclude_icons] - prevent link from firing if there is a button on top that was hit when clicking
  * @param {function} [callback] - if provided creates a new routing. Is called once url matches path and/or hash. May return Promise.
  */
  add(args, callback) {
    let route, hash, path//, routing
    if(args.path &amp;&amp; args.hash) {
      if(args.path[0] != '/') {args.path = '/' + args.path}
      if(this.routes.hasOwnProperty(args.path)) {
        if(args.hash[0] != '#') {args.hash = '#' + args.hash}
        route = args.path + args.hash
        path = args.path
        hash = args.hash
      } else {
        console.error("Can't add hash " + args.hash + " to path " + args.path + ". Path was not added to Routing.")
      }
    } else if (args.path) {
      if(args.path[0] != '/') {args.path = '/' + args.path}
      route = args.path
      path = args.path
    } else if(args.hash) {
      if(args.hash[0] != '#') {args.hash = '#' + args.hash}
      route = args.hash
      hash = args.hash
      path = "/"
    } else {
      if(args[0] != '/') {args = '/' + args}
      route = args
      path = args
    }
    
    if(!this.routes.hasOwnProperty(path)) {
      this.routes[path] = {hash:{}}
    }
    
    if(typeof callback === "function") {
      if(hash) {
        if(this.routes[path].hash.hasOwnProperty(hash)) {
          this.routes[path].hash[hash]["call"] = callback
        } else {
          this.routes[path].hash[hash] = {call: callback}
        }
        if(args.symbolic) {
          this.routes[path].hash[hash]["symbolic"] = args.symbolic
        }
      } else {
        this.routes[path]["call"] = callback
      }
    } else if (this.routes.hasOwnProperty(path)) {
      if(hash) {
        if(this.routes[path].hash.hasOwnProperty(hash)) {
          callback = this.routes[path].hash[hash].call
        }
      } else if(this.routes[path].hasOwnProperty("call")) {
        callback = this.routes[path].call
      }
    }
    
    if(args.hasOwnProperty("link")) { 
      if(args.link.is("a")) {
        args.link.attr("href", this.base_url + route)
      } else {
        args.link.click(e => {
          return new Promise((resolve, reject) => {
            if(args.exclude_icons) {
              if ($(e.target).is('.icon') || $(e.target).is('i')) {
                e.preventDefault();
                return;
              }
            }
            this.show(route)
            this.record()
            if(typeof callback === "function") {
              return Promise.resolve(callback(e))
            } else {
              console.error("no callback bound to link element with route to " + route)
            }
          })
        })
      }
    }
  }
  
  /**
  * show and call a url.  
  * basically window.open relative to base_url
  *
  * @param {string} url - url to be opened
  * @param {string} [target="_self"] - in own window or new window ...
  */
  open(url, target) {
    if(!target) {target = "_self"}
    window.open(this.base_url + url, target)
  }
  
  /**
  * display a url without triggering any callback that was associated with {@link Routing#add}.  
  * yet store url in browser history
  *
  * @param {string} args.path - url path to show
  * @param {Object} args.hash - hash to show
  */
  show(args) {
    let url = ""
    if(args.path &amp;&amp; args.hash) { 
      if(args.hash[0] != '#') {args.hash = '#' + args.hash}
      if(args.path[0] != '/') {args.path = '/' + args.path}
      url = args.path + args.hash
    } else if (args.path) {
      if(args.path[0] != '/') {args.path = '/' + args.path}
      url = args.path
    } else {
      if(args[0] != '/') {args = '/' + args}
      url = args
    }
    history.pushState({base_url:this.base_url}, "", this.base_url + url)
  }
  
  /**
  * check url and, if any, runs callbacks associated with url path and/or hash.
  * 
  * if there is a callback for both path and hash, path callback runs first until it returns. Then hash callback follows except it's symbolic.
  * 
  * records url to history
  */
  review() {
    this.record()
    
    for(let route in this.routes) {
      let path = this.base_url + route.replace(/ /g, '%20')
      
      if(path == window.location.pathname) {
        if(typeof this.routes[route]["call"] === 'function') {
          Promise.resolve(this.routes[route]["call"]({target:this.routes[route]["link"]}))
          .then(result => {
            if(this.routes[route]["hash"].hasOwnProperty(window.location.hash)) {
              if(this.routes[route]["hash"][window.location.hash].hasOwnProperty("call") &amp;&amp; !this.routes[route]["hash"][window.location.hash]["symbolic"]) {
                this.routes[route]["hash"][window.location.hash]["call"]({target:this.routes[route]["hash"][window.location.hash]["link"]})
              }
            }
          })
          .catch(error => {
            console.error(error)
          })
        } else if(this.routes[route]["hash"].hasOwnProperty(window.location.hash)) {
          if(this.routes[route]["hash"][window.location.hash].hasOwnProperty("call")) {
            this.routes[route]["hash"][window.location.hash]["call"]({target:this.routes[route]["hash"][window.location.hash]["link"]})
          }
        } else {
          console.error("no valid functio assigned to " + route)
        }
      }
    }
  }
  
  /**
  * jump to previous url
  */
  undo() {
    console.log("undo")
    console.log(this.history)
    if(this.history.length > 1) {
      this.history.pop()
      this.show(this.history[this.history.length-1])
    } else {
      window.history.back()
    }
  }
  
  /**
  * store current url in local history list
  */
  record() {
    let window_path = window.location.pathname.substring(window.location.pathname.indexOf(this.base_url) + this.base_url.length)
    this.history.push(window_path + window.location.hash)
    console.log("history push: " + window_path + window.location.hash)
  }
  
}
</pre>
    </article>
</section>





		</div>
	</div>

	<div class="clearfix"></div>

	

</div>
</div>


    <div class="modal fade" id="searchResults">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
            <h4 class="modal-title">Search results</h4>
          </div>
          <div class="modal-body"></div>
          <div class="modal-footer">
            <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
          </div>
        </div><!-- /.modal-content -->
      </div><!-- /.modal-dialog -->
    </div>


<footer>

	 | <a href='https://plaitools.gitlab.io/documentation/plaiframe/'>Plaiframe Documentation</a> | <a href='https://plaitools.gitlab.io/documentation/plaiframe/plugins/'>Plugin Documentation</a> | <a href='https://gitlab.com/plaitools'>Plaitools on Gitlab</a>


	<span class="copyright">
	© 2020 Lasse Marburg, Benedikt Kaffai
	</span>

<span class="jsdoc-message">
	Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.6.4</a>
	
		on Fri Feb 5th 2021
	
	using the <a href="https://github.com/docstrap/docstrap">DocStrap template</a>.
</span>
</footer>

<script src="scripts/docstrap.lib.js"></script>
<script src="scripts/toc.js"></script>

    <script type="text/javascript" src="scripts/fulltext-search-ui.js"></script>


<script>
$( function () {
	$( "[id*='$']" ).each( function () {
		var $this = $( this );

		$this.attr( "id", $this.attr( "id" ).replace( "$", "__" ) );
	} );

	$( ".tutorial-section pre, .readme-section pre, pre.prettyprint.source" ).each( function () {
		var $this = $( this );

		var example = $this.find( "code" );
		exampleText = example.html();
		var lang = /{@lang (.*?)}/.exec( exampleText );
		if ( lang && lang[1] ) {
			exampleText = exampleText.replace( lang[0], "" );
			example.html( exampleText );
			lang = lang[1];
		} else {
			var langClassMatch = example.parent()[0].className.match(/lang\-(\S+)/);
			lang = langClassMatch ? langClassMatch[1] : "javascript";
		}

		if ( lang ) {

			$this
			.addClass( "sunlight-highlight-" + lang )
			.addClass( "linenums" )
			.html( example.html() );

		}
	} );

	Sunlight.highlightAll( {
		lineNumbers : true,
		showMenu : true,
		enableDoclinks : true
	} );

	$.catchAnchorLinks( {
        navbarOffset: 10
	} );
	$( "#toc" ).toc( {
		anchorName  : function ( i, heading, prefix ) {
			return $( heading ).attr( "id" ) || ( prefix + i );
		},
		selectors   : "#toc-content h1,#toc-content h2,#toc-content h3,#toc-content h4",
		showAndHide : false,
		smoothScrolling: true
	} );

	$( "#main span[id^='toc']" ).addClass( "toc-shim" );
	$( '.dropdown-toggle' ).dropdown();

    $( "table" ).each( function () {
      var $this = $( this );
      $this.addClass('table');
    } );

} );
</script>



<!--Navigation and Symbol Display-->


<!--Google Analytics-->



    <script type="text/javascript">
        $(document).ready(function() {
            SearcherDisplay.init();
        });
    </script>


</body>
</html>
